
#include <nds.h>

#include "_const.h"
#include "maindef.h"
#include "_console.h"
#include "_consoleWriteLog.h"

#include "memtool.h"
#undef safemalloc
#define safemalloc safemalloc_chkmem
#include "lang.h"
#include "resume.h"
#include "procstate.h"
#include "shell.h"
#include "splash.h"
#include "strtool.h"
#include "inifile.h"
#include "internaldrivers.h"
#include "cwl.h"
#include "strpcm.h"
#include "sndeff.h"
#include "PlaySE.h"

#include "../../ipc6.h"

#include "OSK.h"

#include "unidef.h"

#include "OnSkin.h"
#include "TextEdit.h"

TOSK_GlobalInfo OSK_GlobalInfo;

#include "OSK_KeyMap.h"
#include "OSK_KeyMaps.h"
#include "OSK_KeyMapSelector.h"

static u32 OSK_SelectKeyIdx;

static bool OSK_Shift,OSK_CapsLock;

void OSK_Init(void)
{
  OSKCount=0;
  
  OSK_KeyMaps_Init();
  
  if(Shell_isJPNmode()==true){
    OSK_KeyMaps_ChangeKeyMapIndex(1);
    }else{
    OSK_KeyMaps_ChangeKeyMapIndex(0);
  }

  OSK_SelectKeyIdx=(u32)-1;
  
  OSK_Shift=false;
  OSK_CapsLock=false;
}

void OSK_Free(void)
{
  OSK_KeyMap_Free();
  OSK_KeyMaps_Free();
}

static void OSK_RefreshEnableFlags_ins_SetEnabled(UnicodeChar wc,bool f)
{
  for(u32 idx=0;idx<OSKCount;idx++){
    TOSK *pkm=&OSK[idx];
    if(pkm->pOrgChars[0]==wc) pkm->Enabled=f;
  }
}

static void OSK_RefreshEnableFlags(void)
{
  for(u32 idx=0;idx<OSKCount;idx++){
    TOSK *pkm=&OSK[idx];
    pkm->Enabled=true;
  }
  
  UnicodeChar wc=DicFind_GetLastWChar();
  
  if((wc==0)||(UnicodeChar('0')<=wc)&&(wc<=UnicodeChar('9'))||(wc==UnicodeChar(','))||(wc==UnicodeChar('.'))){
    }else{
    OSK_RefreshEnableFlags_ins_SetEnabled(UnicodeChar('0'),false);
    OSK_RefreshEnableFlags_ins_SetEnabled(UnicodeChar('1'),false);
    OSK_RefreshEnableFlags_ins_SetEnabled(UnicodeChar('2'),false);
    OSK_RefreshEnableFlags_ins_SetEnabled(UnicodeChar('3'),false);
    OSK_RefreshEnableFlags_ins_SetEnabled(UnicodeChar('4'),false);
    OSK_RefreshEnableFlags_ins_SetEnabled(UnicodeChar('5'),false);
    OSK_RefreshEnableFlags_ins_SetEnabled(UnicodeChar('6'),false);
    OSK_RefreshEnableFlags_ins_SetEnabled(UnicodeChar('7'),false);
    OSK_RefreshEnableFlags_ins_SetEnabled(UnicodeChar('8'),false);
    OSK_RefreshEnableFlags_ins_SetEnabled(UnicodeChar('9'),false);
    OSK_RefreshEnableFlags_ins_SetEnabled(UnicodeChar(','),false);
    OSK_RefreshEnableFlags_ins_SetEnabled(UnicodeChar('.'),false);
  }
  
  {
    bool f=false;
    UnicodeChar CanKogakiList[9]={
      /**/ 0x3042,/**/ 0x3044,/**/ 0x3046,/**/ 0x3048,/**/ 0x304a,
      /**/ 0x3064,
      /**/ 0x3084,/**/ 0x3086,/**/ 0x3088,
    };
    for(u32 idx=0;idx<9;idx++){
      if(wc==CanKogakiList[idx]) f=true;
    }
    OSK_RefreshEnableFlags_ins_SetEnabled(UnicodeChar(/**/ 0x5c0f),f);
  }
  
  {
    bool f=false;
    UnicodeChar CanDakutenList[20]={
      /**/ 0x304B,/**/ 0x304D,/**/ 0x304F,/**/ 0x3051,/**/ 0x3053,
      /**/ 0x3055,/**/ 0x3057,/**/ 0x3059,/**/ 0x305B,/**/ 0x305D,
      /**/ 0x305F,/**/ 0x3061,/**/ 0x3064,/**/ 0x3066,/**/ 0x3068,
      /**/ 0x306F,/**/ 0x3072,/**/ 0x3075,/**/ 0x3078,/**/ 0x307B,
    };
    for(u32 idx=0;idx<20;idx++){
      if(wc==CanDakutenList[idx]) f=true;
    }
    OSK_RefreshEnableFlags_ins_SetEnabled(UnicodeChar(/*J*/ 0x309B),f);
  }
  
  {
    bool f=false;
    UnicodeChar CanHanDakutenList[5]={
      /**/ 0x306F,/**/ 0x3072,/**/ 0x3075,/**/ 0x3078,/**/ 0x307B,
    };
    for(u32 idx=0;idx<5;idx++){
      if(wc==CanHanDakutenList[idx]) f=true;
    }
    OSK_RefreshEnableFlags_ins_SetEnabled(UnicodeChar(/*K*/ 0x309C),f);
  }
}

static void OSK_Draw_ins_EOT_Single(CglCanvas *pcan,TOSK *pkm,const u16 TextColor)
{
  const u32 px=pkm->Rect.x,py=pkm->Rect.y;
  const u32 w=pkm->Rect.w,h=pkm->Rect.h;
  
  switch(pkm->pShow[0]){
    case WC_Enter: {
      const u16 col=TextColor;
      pcan->SetColor(col);
      u32 x=px+(w/2),y=py+(h/2);
      x+=2; y-=6;
      pcan->DrawLine(x,y,x,y+12-2);
      y+=12-2;
      pcan->DrawLine(x,y,x-6,y);
      x-=6;
      pcan->SetPixel(x+2,y-2,col);
      pcan->SetPixel(x+1,y-1,col);
      pcan->SetPixel(x+2,y+2,col);
      pcan->SetPixel(x+1,y+1,col);
      pcan->SetPixel(x,y,col);
    } break;
    case WC_Space: {
      const u16 col=TextColor;
      pcan->SetColor(col);
      u32 x=px+(w/2),y=py+(h/2);
      x-=4; y+=4;
      pcan->SetPixel(x,y-1,col);
      pcan->DrawLine(x,y,x+8+1,y);
      x+=8;
      pcan->SetPixel(x,y-1,col);
    } break;
    case WC_BackSpace: {
      const u16 col=TextColor;
      pcan->SetColor(col);
      u32 x=px+(w/2),y=py+(h/2);
      x+=4;
      pcan->DrawLine(x,y,x-8,y);
      x-=8;
      pcan->SetPixel(x+2,y-2,col);
      pcan->SetPixel(x+1,y-1,col);
      pcan->SetPixel(x+2,y+2,col);
      pcan->SetPixel(x+1,y+1,col);
      pcan->SetPixel(x,y,col);
    } break;
    case WC_Shift: {
      const u16 col=TextColor;
      pcan->SetColor(col);
      u32 x=px+(w/2),y=py+(h/2);
      y-=5;
      pcan->SetPixel(x,y,col); y++;
      pcan->SetPixel(x+1,y,col); pcan->SetPixel(x-1,y,col); y++;
      pcan->SetPixel(x+2,y,col); pcan->SetPixel(x-2,y,col); y++;
      pcan->SetPixel(x+3,y,col); pcan->SetPixel(x-3,y,col); y++;
      pcan->SetPixel(x+4,y,col); pcan->SetPixel(x-4,y,col); y++;
      
      pcan->SetPixel(x+4,y,col); pcan->SetPixel(x-4,y,col);
      pcan->SetPixel(x+3,y,col); pcan->SetPixel(x-3,y,col);
      pcan->SetPixel(x+2,y,col); pcan->SetPixel(x-2,y,col); y++;
      
      pcan->SetPixel(x+2,y,col); pcan->SetPixel(x-2,y,col); y++;
      pcan->SetPixel(x+2,y,col); pcan->SetPixel(x-2,y,col); y++;
      pcan->SetPixel(x+2,y,col); pcan->SetPixel(x-2,y,col); y++;
      
      pcan->SetPixel(x+2,y,col); pcan->SetPixel(x-2,y,col);
      pcan->SetPixel(x+1,y,col); pcan->SetPixel(x-1,y,col);
      pcan->SetPixel(x+0,y,col);
      
      if(OSK_Shift==true) OnSkin_FillBox50per(pcan,px+2,py+2,w-2-1,h-2-1,RGB15(20,28,31));
    } break;
    case WC_CapsLock: {
      const u32 tw=pcan->GetTextWidthA("Ca");
      const u32 th=glCanvasTextHeight;
      pcan->SetFontTextColor(TextColor);
      pcan->TextOutA(px+((w-tw)/2),py+((h-th)/2),"Ca");
      if(OSK_CapsLock==true) OnSkin_FillBox50per(pcan,px+2,py+2,w-2-1,h-2-1,RGB15(20,28,31));
    } break;
    default: {
      const u32 tw=pcan->GetTextWidthW(pkm->pShow);
      const u32 th=glCanvasTextHeight;
      pcan->SetFontTextColor(TextColor);
      pcan->TextOutW(px+((w-tw)/2),py+((h-th)/2),pkm->pShow);
    } break;
  }
}

static u32 OSK_GetShiftStateIndex(TOSK *pkm)
{
  bool Shift=OSK_Shift;
  if(OSK_CapsLock==true){
    UnicodeChar wc=pkm->pShow[0];
    if(('a'<=wc)&&(wc<='z')) Shift=!Shift;
    if(('A'<=wc)&&(wc<='Z')) Shift=!Shift;
  }
  
  if(Shift==false){
    return(0);
    }else{
    return(1);
  }
}

static void OSK_Draw_ins_EOT_Shift(CglCanvas *pcan,TOSK *pkm,const u16 TextColor)
{
  const u32 px=pkm->Rect.x,py=pkm->Rect.y;
  const u32 w=pkm->Rect.w,h=pkm->Rect.h;
  
  const UnicodeChar str[2]={pkm->pShow[OSK_GetShiftStateIndex(pkm)],0};
  
  const u32 tw=pcan->GetTextWidthW(str);
  const u32 th=glCanvasTextHeight;
  pcan->SetFontTextColor(TextColor);
  pcan->TextOutW(px+((w-tw)/2),py+((h-th)/2),str);
}

void OSK_Draw(CglCanvas *pcan)
{
  OSK_RefreshEnableFlags(); // ͒ɔfȂƂǂƂ肠ŁB
  
  for(u32 idx=0;idx<OSKCount;idx++){
    TOSK *pkm=&OSK[idx];
    u16 FrameColor,BGColor,TextColor;
    if(idx==OSK_SelectKeyIdx){
      FrameColor=RGB15(0,0,0)|BIT15;
      BGColor=RGB15(15,30,15)|BIT15;
      TextColor=RGB15(4,4,4)|BIT15;
      }else{
      if(pkm->Enabled==false){
        FrameColor=RGB15(24,24,24)|BIT15;
        BGColor=RGB15(31,31,31)|BIT15;
        TextColor=RGB15(24,24,24)|BIT15;
        }else{
        FrameColor=RGB15(16,16,16)|BIT15;
        BGColor=RGB15(31,31,31)|BIT15;
        TextColor=RGB15(4,4,4)|BIT15;
      }
    }
    
    const u32 px=pkm->Rect.x,py=pkm->Rect.y;
    const u32 w=pkm->Rect.w,h=pkm->Rect.h;
    
    pcan->SetColor(FrameColor);
    pcan->DrawBox(px+1,py+1,w-1,h-1);
    
    OnSkin_FillBox50per(pcan,px+2,py+2,w-1-2,h-1-2,BGColor);
    
    switch(pkm->OrgType){
      case EOT_Single: OSK_Draw_ins_EOT_Single(pcan,pkm,TextColor); break;
      case EOT_Shift: OSK_Draw_ins_EOT_Shift(pcan,pkm,TextColor); break;
      case EOT_Multi5: break;
    }
  }
}

static u32 OSK_GetKeyIdxFromPoint(s32 mx,s32 my)
{
  for(u32 idx=0;idx<OSKCount;idx++){
    TOSK *pkm=&OSK[idx];
    if(pkm->Enabled==true){
      const u32 x=pkm->Rect.x,y=pkm->Rect.y;
      const u32 w=pkm->Rect.w,h=pkm->Rect.h;
      if((x<=mx)&&(mx<(x+w))&&(y<=my)&&(my<(y+h))) return(idx);
    }
  }
  return((u32)-1);
}

bool OSK_MouseDown(s32 mx,s32 my)
{
  OSK_SelectKeyIdx=OSK_GetKeyIdxFromPoint(mx,my);
  if(OSK_SelectKeyIdx==(u32)-1) return(false);
  
  if(OSK[OSK_SelectKeyIdx].pOrgChars[0]==WC_Change){
    OSK_SelectKeyIdx=(u32)-1;
    OSK_KeyMapSelector_Execute();
    RequestRedrawMainFlag=true;
    RequestRedrawSubFlag=true;
    return(false);
  }
  
  TOSK *pkm=&OSK[OSK_SelectKeyIdx];
  UnicodeChar wc=pkm->pOrgChars[0];
  
  switch(wc){
    case WC_Enter: break;
    case WC_Space: break;
    case WC_BackSpace: break;
    case WC_Shift: break;
    case WC_CapsLock: break;
    case 0: break;
    default: Sound_Start(WAVFN_MemoPenDown); break;
  }
  
  RequestRedrawMainFlag=true;
  return(true);
}

static bool RequestShiftClear;

static void OSK_MouseUp_ins_EOT_Single(TOSK *pkm)
{
  UnicodeChar wc=pkm->pOrgChars[0];
  
  switch(wc){
    case WC_Enter: case WC_Space: case WC_BackSpace: {
      CB_KeyPress_FromOSK(wc);
    } break;
    case WC_Shift: {
      PlaySE_Short();
      OSK_Shift=!OSK_Shift;
      RequestRedrawSubFlag=true;
      RequestShiftClear=false;
    } break;
    case WC_CapsLock: {
      PlaySE_Long();
      OSK_CapsLock=!OSK_CapsLock;
      RequestRedrawSubFlag=true;
    } break;
    case 0: break;
    default: {
      CB_KeyPress_FromOSK(wc);
    } break;
  }
}

static void OSK_MouseUp_ins_EOT_Shift(TOSK *pkm)
{
  UnicodeChar wc=pkm->pShow[OSK_GetShiftStateIndex(pkm)];
  
  CB_KeyPress_FromOSK(wc);
}

void OSK_MouseUp(s32 mx,s32 my)
{
  if(OSK_SelectKeyIdx==(u32)-1) return;
  
  TOSK *pkm=&OSK[OSK_SelectKeyIdx];
  
  RequestShiftClear=true;
  
  switch(pkm->OrgType){
    case EOT_Single: OSK_MouseUp_ins_EOT_Single(pkm); break;
    case EOT_Shift: OSK_MouseUp_ins_EOT_Shift(pkm); break;
    case EOT_Multi5: break;
  }
  
  if(RequestShiftClear==true) OSK_Shift=false;
  
  OSK_SelectKeyIdx=(u32)-1;
  RequestRedrawMainFlag=true;
}

void OSK_MouseMove(s32 mx,s32 my)
{
  if(OSK_SelectKeyIdx==(u32)-1) return;
  
  if(OSK_SelectKeyIdx!=OSK_GetKeyIdxFromPoint(mx,my)){
    OSK_SelectKeyIdx=(u32)-1;
    RequestRedrawMainFlag=true;
  }
}
